// -*-c++-*-
//  SW4 LICENSE
// # ----------------------------------------------------------------------
// # SW4 - Seismic Waves, 4th order
// # ----------------------------------------------------------------------
// # Copyright (c) 2013, Lawrence Livermore National Security, LLC. 
// # Produced at the Lawrence Livermore National Laboratory. 
// # 
// # Written by:
// # N. Anders Petersson (petersson1@llnl.gov)
// # Bjorn Sjogreen      (sjogreen2@llnl.gov)
// # 
// # LLNL-CODE-643337 
// # 
// # All rights reserved. 
// # 
// # This file is part of SW4, Version: 1.0
// # 
// # Please also read LICENCE.txt, which contains "Our Notice and GNU General Public License"
// # 
// # This program is free software; you can redistribute it and/or modify
// # it under the terms of the GNU General Public License (as published by
// # the Free Software Foundation) version 2, dated June 1991. 
// # 
// # This program is distributed in the hope that it will be useful, but
// # WITHOUT ANY WARRANTY; without even the IMPLIED WARRANTY OF
// # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the terms and
// # conditions of the GNU General Public License for more details. 
// # 
// # You should have received a copy of the GNU General Public License
// # along with this program; if not, write to the Free Software
// # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA 
#include <iostream>
#include <sstream>
#include <cstdlib>

#include "Polynomial.h"

using namespace std;

Polynomial::Polynomial()
{
  for (int q=0; q<3; q++)
  {
    m_c[q] = 0.;
  }
} // end default constructor

Polynomial::Polynomial(double c[3])
{
  for (int q=0; q<3; q++)
  {
    m_c[q] = c[q];
  }
} // end constructor

double Polynomial::coeff(unsigned int q)
{
  return m_c[q];
}

// output all coefficients
ostream& operator<<( ostream& output, const Polynomial& s )
{
  output << "s^0: " << s.m_c[0] << ", s^1: " << s.m_c[1] << ", s^2: " << s.m_c[2];
  return output;
}
